// TestICANGlobal.cpp: implementation of the CTestICANGlobal class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "testicandll.h"
#include "TestICANGlobal.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#define SEC_CFG				"CONFIG"
#define KEY_SYSCFG			"syscfg"

CTestICANGlobal::CTestICANGlobal()
{
	
}

CTestICANGlobal::~CTestICANGlobal()
{

}
map<DWORD,CString> g_type_nameMap;
map<DWORD,DWORD> g_type_cancnt;
void CTestICANGlobal::Init()
{
	//////////////////////////////////////////////////////////////////////////
	g_type_nameMap.insert(std::make_pair(VCI_PCI5121,CString("PCI5121")));
	g_type_nameMap.insert(std::make_pair(VCI_PCI9810,CString("PCI9810")));
	g_type_nameMap.insert(std::make_pair(VCI_USBCAN1,CString("USBCAN1")));
	g_type_nameMap.insert(std::make_pair(VCI_USBCAN2,CString("USBCAN2")));	
	g_type_nameMap.insert(std::make_pair(VCI_PCI9820,CString("PCI9820")));
	g_type_nameMap.insert(std::make_pair(VCI_PCI5110,CString("PCI5110")));	
	g_type_nameMap.insert(std::make_pair(VCI_ISA9620,CString("ISA9620")));
	g_type_nameMap.insert(std::make_pair(VCI_ISA5420,CString("ISA5420")));	
	g_type_nameMap.insert(std::make_pair(VCI_PC104CAN,CString("PC104-CAN")));
	g_type_nameMap.insert(std::make_pair(VCI_CANETE,CString("CANET-UDP")));	
	g_type_nameMap.insert(std::make_pair(VCI_DNP9810,CString("DNP9810")));
	g_type_nameMap.insert(std::make_pair(VCI_PCI9840,CString("PCI9840")));	
	g_type_nameMap.insert(std::make_pair(VCI_PC104CAN2,CString("PC104-CAN2")));
	g_type_nameMap.insert(std::make_pair(VCI_PCI9820I,CString("PCI-9820I")));
	g_type_nameMap.insert(std::make_pair(VCI_CANETTCP,CString("CANET-TCP")));
	g_type_nameMap.insert(std::make_pair(VCI_PEC9920,CString("PEC-9920")));
	g_type_nameMap.insert(std::make_pair(VCI_PCI5010_U,CString("PCI-5010-U")));
	g_type_nameMap.insert(std::make_pair(VCI_USBCAN_E_U,CString("USBCAN-E-U")));
	g_type_nameMap.insert(std::make_pair(VCI_USBCAN_2E_U,CString("USBCAN-2E-U")));
	g_type_nameMap.insert(std::make_pair(VCI_PCI5020_U,CString("PCI-5020-U")));

	g_type_cancnt.insert(std::make_pair(VCI_PCI5121,1/*CString("PCI5121")*/));
	g_type_cancnt.insert(std::make_pair(VCI_PCI9810,1/*CString("PCI9810")*/));
	g_type_cancnt.insert(std::make_pair(VCI_USBCAN1,1/*CString("USBCAN1")*/));
	g_type_cancnt.insert(std::make_pair(VCI_USBCAN2,2/*CString("USBCAN2")*/));	
	g_type_cancnt.insert(std::make_pair(VCI_PCI9820,2/*CString("PCI9820")*/));
	g_type_cancnt.insert(std::make_pair(VCI_PCI5110,1/*CString("PCI5110")*/));	
	g_type_cancnt.insert(std::make_pair(VCI_ISA9620,2/*CString("ISA9620")*/));
	g_type_cancnt.insert(std::make_pair(VCI_ISA5420,2/*CString("ISA5420")*/));	
	g_type_cancnt.insert(std::make_pair(VCI_PC104CAN,1/*CString("PC104-CAN")*/));
	g_type_cancnt.insert(std::make_pair(VCI_CANETE,1/*CString("CANET-UDP")*/));	
	g_type_cancnt.insert(std::make_pair(VCI_DNP9810,1/*CString("DNP9810")*/));
	g_type_cancnt.insert(std::make_pair(VCI_PCI9840,4/*CString("PCI9840")*/));	
	g_type_cancnt.insert(std::make_pair(VCI_PC104CAN2,2/*CString("PC104-CAN2")*/));
	g_type_cancnt.insert(std::make_pair(VCI_PCI9820I,2/*CString("PCI-9820I")*/));
	g_type_cancnt.insert(std::make_pair(VCI_CANETTCP,1/*CString("CANET-TCP")*/));
	g_type_cancnt.insert(std::make_pair(VCI_PEC9920,2/*CString("PEC-9920")*/));
	g_type_cancnt.insert(std::make_pair(VCI_PCI5010_U,1/*CString("PCI-5010-U")*/));
	g_type_cancnt.insert(std::make_pair(VCI_USBCAN_E_U,1/*CString("USBCAN-E-U")*/));
	g_type_cancnt.insert(std::make_pair(VCI_USBCAN_2E_U,2/*CString("USBCAN-2E-U")*/));
	g_type_cancnt.insert(std::make_pair(VCI_PCI5020_U,2/*CString("PCI-5020-U")*/));

	//////////////////////////////////////////////////////////////////////////
	m_syscfg.routecfg.iCardType=VCI_PCI9820;
	m_syscfg.routecfg.iCardInd=0;
	m_syscfg.routecfg.iCANInd=0;
	m_syscfg.routecfg.wCANBaud=0x001c;
	m_syscfg.routecfg.wMasterID=0;
	m_syscfg.routecfg.iMasterCycle=500;

	CString str;
	GetModuleFileName(NULL,str.GetBuffer(MAX_PATH),MAX_PATH);
	str.ReleaseBuffer();
	str=str.Left(str.ReverseFind('\\')+1);
	str+="set.ini";
	m_ini.SetIni((LPTSTR)(LPCTSTR)str);
	
	char sztmp[1024];
	if(m_ini.Read(SEC_CFG,KEY_SYSCFG,sztmp,1024)==1)
	{
		STRTOCFG(sztmp,m_syscfg);
	}

	ROUTECFG cfg;
	cfg.iCardType=m_syscfg.routecfg.iCardType;
	cfg.iCardInd=m_syscfg.routecfg.iCardInd;
	cfg.iCANInd=m_syscfg.routecfg.iCANInd;
	cfg.wCANBaud=m_syscfg.routecfg.wCANBaud;
	cfg.iMasterCycle=m_syscfg.routecfg.iMasterCycle;
	cfg.wMasterID=m_syscfg.routecfg.wMasterID;

	Mgr_AddRoute(cfg,&m_hRoute);
}

void CTestICANGlobal::Uninit()
{
	char sztmp[1024];
	CFGTOSTR(m_syscfg,sztmp);
	m_ini.Write(SEC_CFG,KEY_SYSCFG,sztmp);

}
int CTestICANGlobal::GetCANCount(int devtype)
{
	std::map<DWORD,DWORD>::iterator itr=g_type_cancnt.find(devtype);
	if (itr!=g_type_cancnt.end())
	{
		return itr->second;
	}
	return 0;

// 	switch(devtype)
// 	{
// 	case VCI_PC104CAN:
// 	case VCI_PCI9810:
// 		return 1;
// 		break;
// 	case VCI_PCI9820:
// 	case VCI_USBCAN2:
// 	case VCI_PCI5121:
// 	case VCI_PCI9820I:
// 	case VCI_PEC9920:
// 		return 2;
// 		break;
// 	case VCI_PCI9840:
// 		return 4;
// 		break;
// 	default:
// 		return 0;
// 	}		
}

CString CTestICANGlobal::DatatoStr(BYTE *pdata, int len)
{
	CString strtmp;
	CString str1;
	for(int i=0;i<len;i++)
	{
		str1.Format("%02X ",pdata[i]);
		strtmp+=str1;
	}
	return strtmp;
}
SYSTEMTIME CTestICANGlobal::GetTime()
{
	SYSTEMTIME systime;
	FILETIME filetime,filetime1;
	GetSystemTimeAsFileTime(&filetime);
	FileTimeToLocalFileTime(&filetime,&filetime1);
	FileTimeToSystemTime(&filetime1,&systime);
	return systime;
}

CString CTestICANGlobal::ConvertTimeToStr(SYSTEMTIME tm)
{
	CString str;
	str.Format("%02d:%02d:%02d.%03d",tm.wHour,
		tm.wMinute,
		tm.wSecond, tm.wMilliseconds);								
	return str;
}
